
#define LINE_READY  2
#define LINE_DATA   3
#define LINE_LOAD   4
#define LINE_CLK    5
#define LINE_START  6


void setup() {  

  Serial.begin( 9600 );

  pinMode( LINE_DATA, INPUT );     
  pinMode( LINE_READY, INPUT );
  
  pinMode( LINE_LOAD, OUTPUT );  digitalWrite( LINE_LOAD, HIGH );   
  pinMode( LINE_CLK, OUTPUT );   digitalWrite( LINE_CLK, HIGH );   
  pinMode( LINE_START, OUTPUT ); digitalWrite( LINE_START, HIGH ); 

}

void startV543reading( void ) {
  while ( digitalRead( LINE_READY ) == 0 );  
  digitalWrite( LINE_START, LOW ); // do -\/- pulse
  _delay_us ( 100 );
  digitalWrite( LINE_START, HIGH );   
}

unsigned long readV543rawData( void ) {
  unsigned long rawFrame = 0L;
  int n;  
  while ( digitalRead( LINE_READY ) == 0 );
  digitalWrite( LINE_LOAD, LOW ); // do -\/- pulse
  digitalWrite( LINE_LOAD, HIGH ); 
  digitalWrite( LINE_CLK, LOW );
  for ( n = 31; n >= 0; n-- )  {
    if ( digitalRead( LINE_DATA ) ) {
          rawFrame |= ( (unsigned long)1 << n );
    }     
    digitalWrite( LINE_CLK, HIGH);        
    digitalWrite( LINE_CLK, LOW);
  } // for       
  return rawFrame & 0x03FFFFFFL;
}

void processCommand ( String cmd ) {
  if ( cmd == "START" ) {
    startV543reading();
  }
  if ( cmd == "READ" ) {
    unsigned long raw = readV543rawData(); 
    Serial.println( raw, HEX);          
  }  
}

void loop() {    
    char c = 0x00;
    String rxBuff = "";
    while ( 1 )  {
      if ( Serial.available() > 0 ) {
        c = Serial.read();
        if ( c == '\n' ) { // process on enter
          rxBuff.trim();
          processCommand ( rxBuff );
          rxBuff = "";
        }
        else {
          rxBuff += c;      
          if ( rxBuff.length() > 8 ) {
            rxBuff = ""; // bad way :-(
          }
        }
      }
    }
}
